Author: Luca Boccassi <bluca@debian.org>
Description: temporary support defs from Linux 5.11
 Can be dropped once we have linux-libc-dev 5.11
Forwarded: not appropriate
--- a/introspection/CMakeLists.txt
+++ b/introspection/CMakeLists.txt
@@ -11,6 +11,15 @@
 # Note that the order matters! bpf-static first, the rest later
 if(CMAKE_USE_LIBBPF_PACKAGE AND LIBBPF_FOUND)
 set(bps_libs_to_link bpf-shared ${LIBBPF_LIBRARIES})
+include(CheckCSourceCompiles)
+check_c_source_compiles("#include <linux/bpf.h>\n int main(){ int i=BPF_MAP_TYPE_TASK_STORAGE; return i*0;}" HAVE_BPF_MAP_TYPE_TASK_STORAGE)
+if(NOT HAVE_BPF_MAP_TYPE_TASK_STORAGE)
+  ADD_DEFINITIONS(-DBPF_MAP_TYPE_TASK_STORAGE=BPF_MAP_TYPE_INODE_STORAGE+1)
+endif()
+check_c_source_compiles("#include <linux/bpf.h>\n int main(){ int i=BPF_PROG_TYPE_SYSCALL; return i*0;}" HAVE_BPF_PROG_TYPE_SYSCALL)
+if (NOT HAVE_BPF_PROG_TYPE_SYSCALL)
+  ADD_DEFINITIONS(-DBPF_PROG_TYPE_SYSCALL=BPF_PROG_TYPE_SK_LOOKUP+1)
+endif()
 else()
 set(bps_libs_to_link bpf-static)
 endif()
--- a/src/cc/CMakeLists.txt
+++ b/src/cc/CMakeLists.txt
@@ -15,6 +15,12 @@
 # todo: if check for kernel version
 if (CMAKE_USE_LIBBPF_PACKAGE AND LIBBPF_FOUND)
   include_directories(${LIBBPF_INCLUDE_DIRS})
+  include(CheckCSourceCompiles)
+  check_c_source_compiles("#include <linux/btf.h>\n int main(){ int i=BTF_KIND_FLOAT; return i*0;}" HAVE_BTF_KIND_FLOAT)
+  if (NOT HAVE_BTF_KIND_FLOAT)
+    ADD_DEFINITIONS(-DBTF_KIND_FLOAT=BTF_KIND_DATASEC+1)
+    ADD_DEFINITIONS(-DBTF_KIND_MAX=BTF_KIND_FLOAT)
+  endif()
 else()
   include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libbpf/include)
   include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libbpf/include/uapi)
